<template>
    <div class="relative">
        <div class="mb-2 flex justify-between">
            <div class="flex">
                <v-select-box :modelValue="pageSize" :items="dropItems"
                    @change="(val) => $emit('pageSizeChange', val)" />
            </div>

            <div class="flex items-center space-x-[23px] text-[14px]">
                <div class="flex items-center min-w-[300px]">
                    <div class="relative w-full">
                        <div class="flex absolute inset-y-0 left-0 items-center pl-3 pointer-events-none">
                            <svg aria-hidden="true" class="w-5 h-5 text-gray-500 dark:text-gray-400" fill="currentColor"
                                viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg">
                                <path fill-rule="evenodd"
                                    d="M8 4a4 4 0 100 8 4 4 0 000-8zM2 8a6 6 0 1110.89 3.476l4.817 4.817a1 1 0 01-1.414 1.414l-4.816-4.816A6 6 0 012 8z"
                                    clip-rule="evenodd"></path>
                            </svg>
                        </div>
                        <input type="text"
                            class="bg-gray-50 rounded-full  border border-gray-300 text-gray-900 text-sm focus:ring-blue-500 focus:border-blue-500 block w-full pl-10 p-2.5"
                            placeholder="Search" v-on:keyup.enter="$emit('onSearch')" @change="$emit('onSearch')"
                            :value="search" @input="$emit('update:search', $event.target.value)">
                    </div>
                </div>
                <a class="font-mm font-bold text-[#8787874D]" href="#" @click="onEdit"
                    :class="{ 'text-success': value.length == 1 }">
                    <fa-icon icon="fa-solid fa-pen-to-square" />
                    Edit
                </a>
                <a v-if="isDelete" class="font-mm font-bold" href="#" @click="onDelete"
                    :class="{ 'text-danger': value.length == 1, 'text-[#8787874D]': value.length != 1 }">
                    <fa-icon icon="fa-solid fa-trash" />
                    Delete
                </a>
            </div>
        </div>
        <div class="overflow-x-auto scrollbar">
            <table class="text-sm text-left text-gray-500 dark:text-gray-400 t-table" width="1500px" v-bind="$attrs">
                <thead class="text-xs text-ap-grey-5 uppercase bg-meduim-10">
                    <tr>
                        <th scope="col" class="p-6 w-4 rounded-tl-lg">
                            <!-- <v-checkbox class="text-sm" :checked="value.length == ds.length && ds.length > 0"
                            :fieldId="'row_all'" @update:checked="checkAll($event)" /> -->
                        </th>
                        <th scope="col" class="py-3 px-3">
                            No.
                        </th>
                        <th scope="col" v-for="(col, i) in columns" :key="i" class="py-3 px-6"
                            :class="[{ 'rounded-tr-lg': (i == (columns.length - 1)) }, col?.classes]">
                            {{ col?.name }}
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(row, i) in ds" :key="i" class="bg-white" :class="{ 'bg-[#F7F7FE]': (isOdd(i)) }">
                        <td class="p-4 w-4">

                            <v-checkbox :checked="value.includes(row['id'])" @update:checked="check(row['id'], $event)"
                                :fieldId="'row_' + row['id']" />
                        </td>
                        <td class="py-4 px-3"><span>{{ (i + 1) }}</span></td>
                        <td class="py-4 px-6" v-for="(col, j) in columns" :key="j"
                            :class="[col?.classesRow ? col?.classesRow : col?.classes]">
                            <span v-if="row[col?.field] && col?.isUSD">{{ $filters.currencyUSD(row[col?.field])
                            }}</span>
                            <a href="#" v-else-if="row[col?.field] && !col?.isClick && col?.type == 'date'"
                                @click="this.$emit('onEdit', row.id)">{{ $dayjs(row[col?.field]).format("DD/MMM/YYYY")
                                }}</a>
                            <a href="#" v-else-if="row[col?.field] && !col?.isClick"
                                @click="this.$emit('onEdit', row.id)">{{ row[col?.field] }}</a>
                            <span v-else>{{ row[col?.field] }}</span>
                        </td>
                    </tr>

                </tbody>
                <tbody v-if="ds.length < 0">
                    <tr class="rounded-b-xl">
                        <td class="text-center bg-[#F7F7FE] h-[200px] text-[40px] text-primary"
                            :colspan="columns.length + 2">
                            <fa-icon icon="fa-brands fa-opencart" />
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <nav class="flex justify-between items-center pt-4" aria-label="Table navigation">
            <span class="text-sm font-normal text-gray-500 dark:text-gray-400">Showing <span
                    class="font-semibold text-gray-900 dark:text-white">1-{{ pageSize }}</span> of <span
                    class="font-semibold text-gray-900 dark:text-white">{{ totalRecord }}</span></span>
            <ul class="inline-flex items-center">
                <li>
                    <a href="#" @click="() => {
                        if (current > 1) {
                            $emit('page', 1)
                        }
                    }" :class="{ 'bg-gray-200 hover:bg-gray-200': current == 1 }"
                        class="block py-2 px-3 ml-0 leading-tight text-gray-500 bg-white rounded-l-lg border border-gray-300 hover:bg-gray-100 hover:text-gray-700 dark:bg-gray-800 dark:border-gray-700 dark:text-gray-400 dark:hover:bg-gray-700 dark:hover:text-white">
                        <span class="sr-only">Previous</span>
                        <svg class="w-5 h-[19.5px]" aria-hidden="true" fill="currentColor" viewBox="0 0 20 20"
                            xmlns="http://www.w3.org/2000/svg">
                            <path fill-rule="evenodd"
                                d="M12.707 5.293a1 1 0 010 1.414L9.414 10l3.293 3.293a1 1 0 01-1.414 1.414l-4-4a1 1 0 010-1.414l4-4a1 1 0 011.414 0z"
                                clip-rule="evenodd"></path>
                        </svg>
                    </a>
                </li>
                <li v-for="(i, k) in totalPage" :key="k">
                    <a href="#" @click="$emit('page', i)" aria-current="page"
                        :class="{ 'text-white border-primary bg-primary': current == i }" class="py-2 px-3 border">{{
                                i
                        }}</a>
                </li>
                <li>
                    <a href="#" @click="() => {
                        if (current < totalPage) {
                            $emit('page', (totalPage))
                        }
                    }" :class="{ 'bg-gray-200 hover:bg-gray-200': current == totalPage }"
                        class="block py-2 px-3 leading-tight text-gray-500 bg-white rounded-r-lg border border-gray-300 hover:bg-gray-100 hover:text-gray-700 dark:bg-gray-800 dark:border-gray-700 dark:text-gray-400 dark:hover:bg-gray-700 dark:hover:text-white">
                        <span class="sr-only">Next</span>
                        <svg class="w-4 h-[19.5px]" aria-hidden="true" fill="currentColor" viewBox="0 0 20 20"
                            xmlns="http://www.w3.org/2000/svg">
                            <path fill-rule="evenodd"
                                d="M7.293 14.707a1 1 0 010-1.414L10.586 10 7.293 6.707a1 1 0 011.414-1.414l4 4a1 1 0 010 1.414l-4 4a1 1 0 01-1.414 0z"
                                clip-rule="evenodd"></path>
                        </svg>

                    </a>
                </li>
            </ul>
        </nav>
        <v-confirm-box :modelValue="show" @update:modelValue="onConfirm" />
    </div>
</template>

<script>
import VCheckbox from '@/components/VCheckbox';
import VSelectBox from '../VSelectBox/index.vue';
import VConfirmBox from '../VConfirmBox/index.vue';
import { mapState } from 'vuex';

export default {
    name: 'VTable',
    components: {
        VCheckbox,
        VSelectBox,
        VConfirmBox
    },
    computed: {
        totalPage() {
            return Math.ceil(this.totalRecord / this.pageSize);
        },
        ...mapState(['isOpen', 'isOver'])
    },
    props: {
        ds: {
            type: Array,
            default: () => []
        },
        columns: {
            type: Array,
            default: () => []
        },
        value: {
            type: Array,
            default: () => [],
            required: true,
        },
        pageSize: {
            type: Number,
            default: 20
        },
        current: {
            type: Number,
            default: 1
        },
        totalRecord: {
            type: Number,
            default: 20
        },
        search: {
            type: String,
            default: ''
        },
        isDelete: {
            type: Boolean,
            default: true
        }

    },
    methods: {
        isOdd(i) {
            return (i % 2) == 1;
        },
        check(optionId, checked) {
            let updatedValue = [...this.value];
            if (checked) {
                updatedValue.push(optionId);
            } else {
                updatedValue.splice(updatedValue.indexOf(optionId), 1);
            }
            this.$emit("update:value", updatedValue);
        },
        checkAll(checked) {
            let updatedValue = [];

            if (checked) {
                updatedValue = this.ds.map(item => item.id);
            } else {
                updatedValue = [];
            }

            this.$emit("update:value", updatedValue);
        },
        onEdit() {
            if (this.value.length == 1) {
                this.$emit('onEdit', this.value[0]);
            }
        },
        onDelete() {
            if (this.value.length == 1) {
                this.show = true;
            }
        },

        onConfirm(val) {
            this.show = false;

            if (val) {
                this.$emit('onDelete', this.value[0]);
            }

        }

    },
    data: () => ({
        toolbar: ["Add", "Edit", "Delete", "Update", "Cancel"],
        modelValue: 50,
        show: false,
        dropItems: [
            {
                name: '20',
                value: 20
            },
            {
                name: '50',
                value: 50
            },
            {
                name: '100',
                value: 100
            },
            {
                name: '200',
                value: 200
            },
            {
                name: 'Show all',
                value: 10000
            }
        ]
    }),

}
</script>

<style scoped>
.text-gray-500 {
    /* font-weight: bold; */
    color: black;
}

@media only screen and (min-width: 1920px) {
    .t-table {
        width: 100% !important;
    }
}
</style>
<style lang="scss" scoped>
table,
td {
    background-color: #fff;
}

tr:nth-child(even) td {
    background-color: #d6d8da !important;
}
</style>